                                         |
                         _      _ _      |
                        | |_ __| | |__   |
                        | __/ _` | '_ \  |
                        | || (_| | |_) | |
                         \__\__,_|_.__/  |
                                         |
                          Tcl Debugger   | 
                  =======================+====================================
                       Emacs Integration | softWorks
                              20/08/1996 | personal engineering software 
                                         |
=========================================+====================================
Integration of emacs into the debugger requires the following steps:

add the directory ??/SW/lib to the search path for emacs
libraries. This may be done for all users (file: site-start.el)
or by adding the following lines into your ~/.emacs file:

	-----------------8<-------------------------------------------
	(setq load-path (append (list "??/SW/lib") load-path))
	(autoload 'tdb "tdb4.1" "start communication with a tdb" t nil)

	(define-key tcl-mode-map "\C-c\M-d" 'tdb)
	(define-key tcl-mode-menu [tdb]	'("Connect to tdb" . tdb))
	(define-key tcl-mode-map "\C-x\040" 'tdb-break)
	(define-key tcl-mode-menu [tdb-break]
		'("Set breakpoint in tdb" . tdb-break))
	-----------------8<-------------------------------------------

Don't forget to replace '??' with the actual path where you installed tdb.
You may use a key sequence that better suits your needs or may even
install a global binding (otherwise these bindings are only available
in a tcl-mode buffer):
	
	-----------------8<-------------------------------------------
	(global-set-key "\C-cD" 'tdb)
	-----------------8<-------------------------------------------

This example initiates the connection to tdb as soon as you press
'\C-c\M-d'. Of course you may use 'M-x tdb', other bindings may suit 
your needs better.

Note also that tdb must be already running or the connection will fail
(as far as I know emacs cannot act as server but you emacs gurus may
proove me wrong). 

If the connection is successfull then tdb displays a special icon in
the status line to indicate this fact.

The 'etag' debugger command tries to display the procedure you give as
an argument. For this to work it builds up a TAGS-table (you may also
use this table from within emacs with 'M-.'. tdb must be able to find
the 'etags' programm for this to work (You may change the
configuration variable 'Dbg:Etags' to point at this file). 
(Note that both emacs and tdb must agree on the same pathname for 
this file)

tdb is notified whenever you save a file in emacs. You may arrange to
automatically reload this file into the debugger, postpone the load
until the next 'run' command or to ignore these hints altogether.
See the 'Emacs' menu for details.

You may set temporary hard breakpoints from within emacs. Just position
the cursor at a given point and press "\C-c " (or M-x tdb-break) and
a hard breakpoint will be inserted in the corresponding code. This 
breakpoint is visible to tdb until the procedure is reloaded.


If there is more than one tdb running on the same host and you want to
be able to distinguish between them then you have to do the following:
Every user should change the port number (Dbg:EmacsPort in the
Setup/Config menu) to a unique value (the example uses 6212). This will
create/modify a file ~/.SW/tdb.cfg which looks something like the
following file:

	-------------8<-----------------
	; Config 1996/08/20-11:38, risc

	[Dbg]
	EmacsPort=6212

	; EOF    
	-------------8<-----------------

The same number should be used when you add the
following statement to your .emacs:
	
	-----------------8<-------------------------------------------
	(setq tdb-port 6212)
	-----------------8<-------------------------------------------

After a restart of both tdb and emacs you should have your private
connection...

If something goes really wrong (you never know for sure, don't you) then
you may kill the connection (menu 'Emacs/Disconnect') and restart it
(from emacs, see above, sorry).
==============================================================================

